
<?php
include('Net/SSH2.php');
class LibSSH2
{

    private $host = NULL;
    private $user = NULL;
    private $port = NULL;
    private $password = NULL;
    private $con = null;

    public function connect( $host, $port, $skiperror = false )
    {
        $this->host = $host;
        $this->port = $port;
        $this->con = ssh2_connect( $this->host, $this->port );
        if ( !$this->con )
        {
            if ( $skiperror )
            {
                return false;
            }
            exit( "Connection failed !" );
        }
    }

    public function authPassword( $user, $password, $skiperror = false )
    {
        $this->user = $user;
        $this->password = $password;
        if ( !ssh2_auth_password( $this->con, $this->user, $this->password ) )
        {
            if ( $skiperror )
            {
                return false;
            }
            exit( "Authorization failed !" );
        }
    }

    public function cmdExec( $cmd ,$ip,$pass,$port);
    {
        $response = "";
        include('Net/SSH2.php');

$ssh2 = new Net_SSH2($ip);
if (!$ssh->login('root', $pass)) {
    exit('Login Failed');
}
 $stream =$ssh2->exec($cmd );
 
        stream_set_blocking( $stream, true );
        while ( $stream && ( $buffer = fgets( $stream ) ) !== false )
        {
            $response .= $buffer;
        }
        return $response;
    }

    public function isConnected( )
    {
        if ( $this->con == null )
        {
            return false;
        }
        return true;
    }

}

class VMware
{

    private $ssh = null;
    private $config = null;
    private $vm_all_array = null;
    private $total_vm = null;
    private $ip = null;
    private $port = null;
    private $user = null;
    private $pass = null;

    public function VMware( )
    {
        $this->ssh = new LibSSH2( );
    }

    public function setServerConfig( $ip, $user, $pass, $port = 22 )
    {
        $this->ip = $ip;
        $this->user = $user;
        $this->pass = $pass;
        $this->port = $port;
    }

    protected function connect( )
    {
        if ( $this->ip == null )
        {
            exit( "Cannot connect to vmware server" );
        }
        $this->ssh->connect( $this->ip, $this->port );
        $this->ssh->authPassword( $this->user, $this->pass );
        return true;
    }

    protected function exec( $cmd )
    {
              $response = $this->ssh->cmdExec( $cmd ,$this->ip,$this->pass,$this->port);
        return $response;
    }

    public function getAllVmInfo( )
    {
        if ( $this->vm_all_array == null )
        {
            $response = $this->exec( "vim-cmd vmsvc/getallvms" );
            $this->vm_all_array = $this->parsAllVmInfo( $response );
        }
        return $this->vm_all_array;
    }

    public function getSummaryInfo( $vmid )
    {
        $this->vm_info_array = null;
        $response = $this->exec( "vim-cmd vmsvc/get.summary {$vmid}" );
        return $this->parsInfo( $response );
    }

    public function getGuestInfo( $vmid )
    {
        $this->vm_info_array = null;
        $response = $this->exec( "vim-cmd vmsvc/get.guest {$vmid}" );
        return $this->parsInfo( $response );
    }

    public function getDataStoreInfo( $vmid )
    {
        $this->vm_info_array = null;
        $response = $this->exec( "vim-cmd vmsvc/get.datastore {$vmid}" );
        return $this->parsDataStoreInfo( $response );
    }

    protected function parsDataStoreInfo( $response )
    {
        $storageArr = array( );
        preg_match( "/freespace *?(\\d{1,})/i", $response, $freespace );
        preg_match( "/capacity *?(\\d{1,})/i", $response, $capacity );
        $storageArr['freespace'] = $freespace[1];
        $storageArr['capacity'] = $capacity[1];
        return $storageArr;
    }

    protected function parsInfo( $response )
    {
        $response = preg_replace( "@\\(vim.*\\)@", "", $response );
        $response = preg_replace( "@([^ ]*) =@", "\"\$1\" =>", $response );
        $search = array( "<unset>", "(string)", "{", "}", "[", "]", "Listsummary:", "Guest information:" );
        $replace = array( "null", "", "array(", ")", "", "", "", "" );
        $response = str_replace( $search, $replace, $response );
        $response = addcslashes( $response, "\\" );
        @eval( "\$arr = ".$response.";" );
        if ( $arr == null )
        {
            return false;
        }
        return $arr;
    }

    protected function parsAllVmInfo( $response )
    {
        if ( preg_match_all( "@^(\\d+) {2,}([^\\[\\]]+)\\[.*\\].*/(.*\\.vmx) {2,}([a-zA-Z]+)@m", $response, $matches ) )
        {
            $total = count( $matches[1] );
            $parsed_array = array( );
            $i = 0;
            while ( $i < $total )
            {
                $vm_arr = array( );
                $vm_arr['vmid'] = trim( $matches[1][$i] );
                $vm_arr['name'] = trim( $matches[2][$i] );
                $vm_arr['filename'] = trim( $matches[3][$i] );
                $os = strtolower( trim( $matches[4][$i] ) );
                if ( stripos( $os, "win" ) !== false )
                {
                    $os = "WIN";
                }
                else if ( stripos( $os, "linux" ) !== false )
                {
                    $os = "LINUX";
                }
                else
                {
                    $os = "OTHER";
                }
                $vm_arr['os'] = $os;
                $parsed_array[] = $vm_arr;
                ++$i;
            }
            $this->total_vm = $total;
            return $parsed_array;
        }
        return false;
    }

    public function powerOFF( $vmid )
    {
        $response = $this->exec( "vim-cmd vmsvc/power.off {$vmid}" );
        if ( stripos( $response, "failed" ) === false )
        {
            return true;
        }
        return false;
    }

    public function powerON( $vmid )
    {
        $response = $this->exec( "vim-cmd vmsvc/power.on {$vmid}" );
        if ( stripos( $response, "failed" ) === false )
        {
            return true;
        }
        return false;
    }

    public function reset( $vmid )
    {
        $response = $this->exec( "vim-cmd vmsvc/power.reset {$vmid}" );
        if ( stripos( $response, "failed" ) === false )
        {
            return true;
        }
        return false;
    }

    public function rebootOS( $vmid )
    {
        $response = $this->exec( "vim-cmd vmsvc/power.reboot {$vmid}" );
        if ( stripos( $response, "failed" ) === false )
        {
            return true;
        }
        return false;
    }

    public function shutdownOS( $vmid )
    {
        $response = $this->exec( "vim-cmd vmsvc/power.shutdown {$vmid}" );
        if ( stripos( $response, "failed" ) === false )
        {
            return true;
        }
        return false;
    }

    public function suspend( $vmid )
    {
        $response = $this->exec( "vim-cmd vmsvc/power.suspend {$vmid}" );
        if ( stripos( $response, "failed" ) === false )
        {
            return true;
        }
        return false;
    }

    public function getState( $vmid )
    {
        $response = $this->exec( "vim-cmd vmsvc/power.getstate {$vmid}" );
        return $this->parsStateInfo( $response );
    }

    protected function parsStateInfo( $response )
    {
        if ( stripos( $response, "notfound" ) !== false || trim( $response ) == "" )
        {
            return "NOTFOUND";
        }
        return strtolower( trim( str_replace( array( "Retrieved runtime info", "" ), array( "", "" ), $response ) ) );
    }

    public function isVmIdExist( $vmid )
    {
        if ( $this->getState( $vmid ) == "NOTFOUND" )
        {
            return false;
        }
        return true;
    }

    public function getTotalVm( )
    {
        if ( $this->total_vm == null && $this->vm_all_array == null )
        {
            $this->getAllVmInfo( );
            if ( $this->total_vm == null )
            {
                return false;
            }
        }
        return $this->total_vm;
    }

    public function getImportantInfo( $vmid )
    {
        $vminfoArr = $this->getSummaryInfo( $vmid );
        if ( $vminfoArr === false )
        {
            return false;
        }
        $info = array( );
        $info['vmid'] = $vmid;
        $info['memorySize'] = intval( $vminfoArr['config']['memorySizeMB'] );
        $info['memoryUsage'] = intval( $vminfoArr['quickStats']['guestMemoryUsage'] );
        $info['cpuMax'] = intval( $vminfoArr['runtime']['maxCpuUsage'] );
        $info['bootTime'] = str_replace( "T", " ", $vminfoArr['runtime']['bootTime'] );
        $os = strtolower( trim( $vminfoArr['guest']['guestId'] ) );
        if ( stripos( $os, "win" ) !== false )
        {
            $os = "WIN";
        }
        else if ( stripos( $os, "linux" ) !== false )
        {
            $os = "LINUX";
        }
        else
        {
            $os = "OTHER";
        }
        $info['os'] = $os;
        $info['osFullName'] = trim( $vminfoArr['guest']['guestFullName'] );
        $info['hostname'] = $vminfoArr['guest']['hostName'];
        $info['ip'] = $vminfoArr['guest']['ipAddress'];
        $info['powerState'] = strtolower( trim( $vminfoArr['runtime']['powerState'] ) );
        $info['cpuUsage'] = intval( $vminfoArr['quickStats']['overallCpuUsage'] );
        $info['uptime'] = intval( $vminfoArr['quickStats']['uptimeSeconds'] );
        $guest = $this->getGuestInfo( $vmid );
        $info['hd'] = round( abs( $guest['disk']['capacity'] ) / ( 1024 * 1024 * 1024 ), 2 );
}
}
?>